var ws_socket, ws_connected=0, ws_onconnect=false, ws_ondisconnect=false;

function ws_disconnected() {
		if (ws_socket.readyState!=ws_socket.CLOSED)
				ws_socket.close();

		ws_connected = 0;

		window.setTimeout("ws_connect()", 1000);

		if (ws_ondisconnect)
				ws_ondisconnect();
}


function ws_invoke_arg(win, func, data) {
		if (data.length && (typeof data == 'object')) {
				if (data.length==2)
						win[func](data[0], data[1]);
				else if (data.length==3)
						win[func](data[0], data[1], data[2]);
				else if (data.length==5)
						win[func](data[0], data[1], data[2], data[3], data[4]);
				else if (data.length==11)
						win[func](data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7], data[8], data[9], data[10]);
				else 
						win[func](data);
		} else {
				win[func](data);
		}
}

function ws_callback(event) {
		if (ws_connected==0) {
				ws_connected = 1;

				if (ws_onconnect)
						ws_onconnect();
		}
		
		if (event.data instanceof ArrayBuffer) {
				if (parent.frames.length>1) {
						if (parent.frames[0]["ess_dead_channels"])
								ws_invoke_arg(parent.frames[0], "ess_dead_channels", event.data);
						if (parent.frames[1] && parent.frames[1]["ess_dead_channels"])
								ws_invoke_arg(parent.frames[1], "ess_dead_channels", event.data);
				} else if (window["ess_dead_channels"]) {
						ws_invoke_arg(window, "ess_dead_channels", event.data);
				}
				
		} else {
				var rpc = false;

				try {
						rpc = JSON.parse(event.data);
 				} catch (e) {
						alert(event.data+"\n"+e);
				}
				
				if (rpc) {
						try {
								if (rpc.length==1) { // no arguments
										if (parent.frames.length>1) {
												if (parent.frames[0][rpc[0]])
														parent.frames[0][rpc[0]]();
												if (parent.frames[1] && parent.frames[1][rpc[0]])
														parent.frames[1][rpc[0]]();
										} else if (window[rpc[0]]) {
												window[rpc[0]]();
										}
								} else if (rpc.length==2) {
										if (parent.frames.length>1) {
												if (parent.frames[0][rpc[0]])
														try {
																ws_invoke_arg(parent.frames[0], rpc[0], rpc[1]);
														} catch (e) {}
												if (parent.frames[1] && parent.frames[1][rpc[0]])
														try {
																ws_invoke_arg(parent.frames[1], rpc[0], rpc[1]);
														} catch (e) {
														    //alert(e);
														}
										} else if (window[rpc[0]]) {
												ws_invoke_arg(window, rpc[0], rpc[1]);
										}
								}
						} catch (e) {
						}
				}
		}
}


function ws_connect() {
		try {
				ws_socket = new WebSocket('ws://'+window.location.host+'/ws/events');
				ws_socket.binaryType = "arraybuffer";
				ws_socket.onmessage = ws_callback;
				ws_socket.onclose = ws_disconnected;   
		} catch (e) {
		} 
}


function ws_init(onconnect, ondisconnect) {
		if ("WebSocket" in window) {
				ws_connect();
				ws_onconnect = onconnect;
				ws_ondisconnect = ondisconnect;

		} else {
				if (parent.frames[1]) 
						parent.frames[1].location = '/en/browser.html';
				else
						top.location = '/en/browser.html';
		}
}
