#!/bin/bash

#ethtool -s eth0 speed 10 duplex half autoneg off
/system/checkosc.sh 

if [ ! -e /tmp/OSC ]; then
  ethtool -s eth0 speed 10 duplex half autoneg off
fi

ifconfig eth0 down
sleep 1
ifconfig eth0 up

# GPI 1-4
echo 23 > /sys/class/gpio/export
echo "in" > /sys/class/gpio/gpio23/direction
echo 28 > /sys/class/gpio/export
echo "in" > /sys/class/gpio/gpio28/direction
echo 25 > /sys/class/gpio/export
echo "in" > /sys/class/gpio/gpio25/direction
echo 51 > /sys/class/gpio/export
echo "in" > /sys/class/gpio/gpio51/direction

# GPO 1-4
echo 39 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio39/direction
echo 40 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio40/direction
echo 41 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio41/direction
echo 42 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio42/direction

# MCU_MASTER
echo 54 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio54/direction
echo 1 > /sys/class/gpio/gpio54/value
echo 55 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio55/direction
echo 1 > /sys/class/gpio/gpio55/value

# PROG_B
echo 56 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio56/direction
echo 1 > /sys/class/gpio/gpio56/value
echo 59 > /sys/class/gpio/export
echo "out" > /sys/class/gpio/gpio59/direction
echo 1 > /sys/class/gpio/gpio59/value

# FPGA_DONE
echo 126 > /sys/class/gpio/export
echo "in" > /sys/class/gpio/gpio126/direction


# Flash FPGA?

if [ -e /fpga/flash ]; then
  /system/fpga_flash.sh /fpga/flash && rm /fpga/flash
  reboot
fi


