#!/bin/sh

# support script v3 (2018-03-23)

touch /f_support

/system/controld --version >/tmp/versions
/system/frontpaneld --version >> /tmp/versions
/system/donetd --version >> /tmp/versions
/system/doppelgaengerd --version >> /tmp/versions
/system/jupiterd --version >> /tmp/versions
/system/fand --version >>/tmp/versions
/system/gpiod --version >>/tmp/versions
/system/httpd --version >>/tmp/versions
/system/mdnsd --version >>/tmp/versions
/system/midid --version >>/tmp/versions
/system/swp08d --version >>/tmp/versions
/system/syncd --version >>/tmp/versions
/system/telnetd --version >>/tmp/versions
/system/tempd --version >>/tmp/versions

dmesg > /tmp/dmesg
/system/dump > /tmp/dump
cat /sys/class/mmc_host/mmc0/mmc0\:*/* > /tmp/mmc 2>/dev/null
cat /sys/kernel/debug/mmc0/ios  > /tmp/ios
df > /tmp/df
free > /tmp/free

tar -zc /f_support /tmp/free /tmp/df /tmp/sync* /tmp/versions /tmp/dmesg /tmp/dump /tmp/mmc /tmp/ios /var/log/messages* /config /user /static /static_archive 2>/dev/null

rm /tmp/dmesg /tmp/versions /tmp/dump /tmp/mmc /tmp/ios /tmp/df /tmp/free
