
function search_callback(response) {
	var rows = response.split('\n');
	var d = document.getElementById('searchresults');
	var str = "";

	if (rows.length<3) {
		alert("No such thing found, and nothing similar.");
		d.style.display = 'none';
	} else {
		for (i=0; i+2<rows.length; i+=3) {
			str += '<a href="/en/help/'+rows[i+2]+'">'+rows[i+1]+' ('+rows[i]+' hits)</a>';
		}
		d.innerHTML = str;
		d.style.display = 'block';
	}
}

function search_click(e) {
	var d = document.getElementById('searchresults');
	if (e.srcElement != d) {
		if (d.style.display=='block')
			d.style.display = 'none';
	}
	return false;
}

function search(keyword) {
	post_call('/help/search', keyword, search_callback);
}

document.addEventListener('mouseup', search_click, true);  
